<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Login</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
</head>
<body>
    <div class="container jumbotron mt-5" >
        <form id="login-form">
            <div class="form-group">
                <label for="exampleInputEmail1">Email address</label>
                <input type="email" class="form-control" id="email" aria-describedby="emailHelp" required>
                <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone else.</small>
            </div>
            <div class="form-group">
                <label for="exampleInputPassword1">Password</label>
                <input type="password" class="form-control" id="password" required>
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>    
    </div>

    <script>
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_STATUS_CREATED = 201;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
        const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";

        var gInputForm = document.getElementById("login-form");
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        gInputForm.addEventListener("submit", function(e) {
            //loai bo cac su kien mac dinh tren form            
            e.preventDefault();

            //xu ly su kien login
            login();
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //xu ly su kien login
        function login() {
            //B0: khai bao doi tuong de thu thap du lieu
            var vLoginData = {
                email:"",
                password:""
            }
            //B1: thu thap du lieu
            getLoginData(vLoginData);

            //B2: kiem tra du lieu
            var vValid = validateLoginData(vLoginData);

            
            if (vValid) {
                //B3: ket noi api
                const vLoginObj = new URLSearchParams(vLoginData);
                var vXmlHttpLogin = new XMLHttpRequest();
                callLoginApi(vXmlHttpLogin, vLoginObj);

                vXmlHttpLogin.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                            //B4: hien thi ket qua
                            displayResult(vXmlHttpLogin.responseText)
                        }
                    }                
                
            }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //ham thu thap du lieu
        function getLoginData(paramLoginData) {
            var vEmailEle = document.getElementById("email");
            var vpasswordEle = document.getElementById("password");

            paramLoginData.email = vEmailEle.value;
            paramLoginData.password = vpasswordEle.value;
        }

        //ham kiem tra du lieu
        function validateLoginData(paramLoginData) {
            //kiem tra dinh dạng email
            if (!validateEmail(paramLoginData.email)) {
                alert("Email không đúng định dạng");
                return false;
            }

            //kiem tra dinh dang password
            if (paramLoginData.password.length < 5) {
                alert("Độ dài mật khẩu phải từ 5 ký tự");
                return false;
            }

            return true;
        }

        //Hàm kiểm tra định dạng email
        function validateEmail(paramEmail) {
            var vRegexEmail = /^[a-zA-Z0-9_]+@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*$/;
            if (paramEmail.match(vRegexEmail)) {
                return true;
            } else {
                return false;
            }
        }

        //ham goi api login
        function callLoginApi(paramXmlHttpLogin, paramLoginObj) {
            paramXmlHttpLogin.open("GET", gBASE_URL + "?" + paramLoginObj.toString(), true);
            paramXmlHttpLogin.send();
        }

        //Hàm hiển thị kết quả
        function  displayResult(paramLoginData) {
            console.log(paramLoginData);
        }
                            
    </script>    
</body>
</html>